unit Unit1;

interface

uses Windows, Messages, SysUtils, Classes, Controls, Forms, WinSock, StdCtrls, Registry;

type
  TForm1 = class(TForm)
    Button2: TButton;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
  end;

const
  Key = 'SOFTWARE\InetTimeSync\Options';

var
  Form1: TForm1;
  client:TSocket;
  WSAData: TWSAData;
  INIReg:TRegInifile;

implementation

{$R *.dfm}

function SetLocalTime(dSysTime: TSystemTime): boolean;
var
 buffer: DWord;
 tkp, tpko: TTokenPrivileges;
 hToken: THandle;
begin
 Result := False;
 if SysUtils.Win32Platform = VER_PLATFORM_WIN32_NT then  begin
  if not Windows.OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then exit;
  Windows.LookupPrivilegeValue(nil, 'SE_SYSTEMTIME_NAME', tkp.Privileges[0].Luid); 
  tkp.PrivilegeCount:=1;
  tkp.Privileges[0].Attributes:=SE_PRIVILEGE_ENABLED;
  if not Windows.AdjustTokenPrivileges(hToken, FALSE, tkp, sizeof(tkp), tpko, buffer) then exit;
 end;
 Result := Windows.SetLocalTime(dSysTime);
 SendMessage(HWND_TOPMOST, WM_TIMECHANGE, 0, 0);
 if SysUtils.Win32Platform = VER_PLATFORM_WIN32_NT then begin
  Windows.AdjustTokenPrivileges(hToken, False, tpko, SizeOf(tpko), tkp, Buffer);
  Windows.CloseHandle(hToken);
 end;
end;

function ExtractTime(buf: string): TSystemTime;
 var i:integer;
 c:string;
begin                      // |09:31:16 PM, Monday 03, August 2009|
 result.wHour:=strtoint(copy(buf,1,2));
 if (buf[10]='P')and(result.wHour<>12) then inc(result.wHour,12);
 if (buf[10]='A')and(result.wHour=12) then result.wHour:=0;

 result.wMinute:=strtoint(copy(buf,4,2));

 result.wSecond:=strtoint(copy(buf,7,2));

 result.wMilliseconds:=500;

 i:=pos(',',buf);
 delete(buf,1,i+1);
 i:=pos('y',buf);
 c:=copy(buf,1,i);
 if c='Monday'    then result.wDayOfWeek:=1;
 if c='Tuesday'   then result.wDayOfWeek:=2;
 if c='Wednesday' then result.wDayOfWeek:=3;
 if c='Thursday'  then result.wDayOfWeek:=4;
 if c='Friday'    then result.wDayOfWeek:=5;
 if c='Saturday'  then result.wDayOfWeek:=6;
 if c='Sunday'    then result.wDayOfWeek:=7;
 delete(buf,1,i+1);

 result.wDay:=strtoint(copy(buf,1,2));

 c:=copy(buf,5,3);
 if c='Jan' then result.wMonth:=1;
 if c='Feb' then result.wMonth:=2;
 if c='Mar' then result.wMonth:=3;
 if c='Apr' then result.wMonth:=4;
 if c='May' then result.wMonth:=5;
 if c='Jun' then result.wMonth:=6;
 if c='Jul' then result.wMonth:=7;
 if c='Aug' then result.wMonth:=8;
 if c='Sep' then result.wMonth:=9;
 if c='Oct' then result.wMonth:=10;
 if c='Nov' then result.wMonth:=11;
 if c='Dec' then result.wMonth:=12;

 c:=(copy(buf,pos('<',buf)-4,4));
 result.wYear:=strtoint(c);
end;

function CheckData(Sock: TSocket): boolean;
var
  Res,Count: integer;
begin
  Res:=WinSock.ioctlsocket(Sock,FIONREAD,Longint(Count));
  if Res=SOCKET_ERROR then raise Exception.Create(Format('Error %d while receiving data: %s',[WSAGetLastError,SysErrorMessage(WSAGetLastError)]));
  Result:=Count>0;
end;

function ReceiveData(Sock: TSocket; var P: Pointer): integer;
var
  Res: integer;
begin
  P:=nil;
  Result:=0;
  repeat
    ReallocMem(P,Result+3072);
    Res:=WinSock.recv(Sock,Pointer(PChar(P)+Result)^,3072,0);
    if Res=SOCKET_ERROR then raise Exception.Create(Format('Error %d while receiving data: %s',[WSAGetLastError,SysErrorMessage(WSAGetLastError)])) else
      if Res=0 then break else inc(Result,Res);
    sleep(200);
    Application.ProcessMessages;
    if not CheckData(Sock) or Application.Terminated then break;
  until FALSE;
  ReallocMem(P,Result);
end;

function ReceiveString(Sock: TSocket): string;
var
  P: Pointer;
  Sz: integer;
begin
  Sz:=ReceiveData(Sock,P);
  if Sz>0 then try
    SetLength(Result,Sz);
    Move(P^,PChar(Result)^,Sz);
  finally
    FreeMem(P,Sz);
  end;
end;

procedure ReadProc;
 var buf:string;
 Sz: integer;
 t:TSystemTime;
begin
 buf:=ReceiveString(client);
 if buf<>'' then begin
  sz:=pos('id="currentTime">',buf);
  if sz=0 then begin Form1.Button2Click(nil); exit; end;
  delete(buf,1,sz+16);
  sz:=pos('<',buf);
  buf:=copy(buf,1,sz);
  t:=ExtractTime(buf);
  if SetLocalTime(t) then begin
   delete(buf,length(buf),1);
   form1.Edit1.Text:=buf;
   form1.Caption:='!';
  end else form1.Caption:=',   ...';; 
 end else begin
  form1.Caption:=',   ...';
  form1.Edit1.Text:=''; 
 end;        
 Shutdown(client,SD_Both);
 Closesocket(client);
end;

procedure SendData(Sock: TSocket; const Buf; Sz: integer);
 var Res,Sent: integer;
begin
 Sent:=0;
 while (Sent<Sz) and not Application.Terminated do begin
  Res:=WinSock.send(Sock,(PChar(@Buf)+Sent)^,Sz-Sent,0);
  if Res<>SOCKET_ERROR then inc(Sent,Res) else break;
 end;
end;

function IPToHost(IPAddr : String): String;
var
 SockAddrIn: TSockAddrIn;
 HostEnt: PHostEnt;
begin
 SockAddrIn.sin_addr.s_addr:= inet_addr(PChar(IPAddr));
 HostEnt:= gethostbyaddr(@SockAddrIn.sin_addr.S_addr, 4, AF_INET);
 if HostEnt<>nil then
  begin
   result:=string(Hostent^.h_name);
  end
 else result:='';
end;

function HostToIP(Name: string; var Ip: string): Boolean;
var
 hostName:array [0..255] of char;
 hostEnt:PHostEnt;
 addr:PChar;
begin
 gethostname (hostName, sizeof (hostName));
 StrPCopy(hostName, Name);
 hostEnt := gethostbyname (hostName);
 if Assigned (hostEnt) then
  if Assigned (hostEnt^.h_addr_list) then begin
    addr := hostEnt^.h_addr_list^;
    if addr<>nil then begin
      IP := Format ('%d.%d.%d.%d', [byte (addr [0]),byte (addr [1]), byte (addr [2]), byte (addr [3])]);
      Result := True;
    end else Result := False;
   end else Result := False
 else Result := False;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var temp:string;
 Addr:TSockAddr;
begin
 client:=Socket(AF_INET,SOCK_STREAM,0);
 if client<>INVALID_SOCKET then begin
  Addr.sin_family:=AF_Inet;
  if checkbox1.Checked then begin // 
   Addr.sin_port:=HToNS(strtoint(edit3.Text));
   if IPToHost(edit2.Text)<>'' then 
   Addr.sin_addr.S_addr:=Inet_Addr(pchar(edit2.Text)) else
   Addr.sin_addr.S_addr:=Inet_Addr('0');
  end else begin                // 
   Addr.sin_port:=HToNS(80);
   HostToIP('24timezones.com',temp);
   Addr.sin_addr.S_addr:=Inet_Addr(pchar(temp));
  end;

  FillChar(Addr.Sin_Zero,SizeOf(Addr.Sin_Zero),0);
  if Connect(client,Addr,SizeOf(TSockAddr))<>0 then
     form1.Caption:='   !'
   else begin
    form1.Caption:='  '+inet_ntoa(addr.sin_addr);

    temp:='GET /world_directory/current_kyiv_time.php HTTP/1.1'+#13#10+
    'Host: 24timezones.com'+#13#10+    //,     
    'Connection: close'+#13#10#13#10;

    form1.Edit1.Text:=',   ...';
    application.ProcessMessages;
    SendData(client,PChar(temp)^,Length(temp)); //  
    ReadProc;   //  
   end;
 end;  
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 if WSAStartUp($0101,WSAData)<>0 then MessageBox(form1.Handle,' ','Error',MB_OK);
 INIReg:=TRegInifile.Create;
 checkbox1.Checked:=INIReg.ReadBool(Key,'UseProxy',false);
 edit2.Text:=INIReg.ReadString(Key,'Proxy','10.10.2.3');
 edit3.Text:=INIReg.ReadString(Key,'Port','3128');
 form1.Top:=INIReg.ReadInteger(Key,'Top',(screen.Height div 2)-form1.Height div 2);
 form1.Left:=INIReg.ReadInteger(Key,'Left',(screen.Width div 2)-form1.Width div 2);
 INIReg.CloseKey;
 INIReg.Free;
 CheckBox1Click(nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 WSACleanup;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if CheckBox1.Checked then begin
  edit2.Visible:=true;
  edit3.Visible:=true;
  label1.Visible:=true;
 end else begin
  edit2.Visible:=false;
  edit3.Visible:=false;
  label1.Visible:=false;
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 INIReg:=TRegInifile.Create;
  INIReg.WriteBool(Key,'UseProxy',checkbox1.Checked);
  INIReg.WriteString(Key,'Proxy',edit2.Text);
  INIReg.WriteString(Key,'Port',edit3.Text);
  INIReg.WriteInteger(Key,'Top',form1.Top);
  INIReg.WriteInteger(Key,'Left',form1.Left);
 INIReg.CloseKey;
 INIReg.Free;
end;

end.
